[leetcode] Intersection of Two Linked Lists


Intersection of Two Linked Lists

Write a program to find the node at which the intersection of two singly linked lists begins.
For example, the following two linked lists:

A:          a1 → a2
                   ↘
                     c1 → c2 → c3
                   ↗            
B:     b1 → b2 → b3

begin to intersect at node c1.
Notes:

  • If the two linked lists have no intersection at all, return null.
  • The linked lists must retain their original structure after the function returns.
  • You may assume there are no cycles anywhere in the entire linked structure.
  • Your code should preferably run in O(n) time and use only O(1) memory.

Credits:
Special thanks to @stellari for adding this problem and creating all test cases.

Show Tags:

这题挺有意思,要求线性时间,常数空间。先不管它,尝试暴力搜。时间复杂度O(n^2)

方案一:

/**
 * Definition for singly-linked list.
 * struct ListNode {
 *     int val;
 *     ListNode *next;
 *     ListNode(int x) : val(x), next(NULL) {}
 * };
 */
class Solution {
public:
    ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) {
        ListNode * pa = headA;
        ListNode * pb;
        while(pa != NULL){
            pb = headB;
            while(pb != NULL){
                
                /*find intersection*/
                if (pa == pb){
                    return pa;
                }
                else{
                    pb = pb->next;
                }
            }
            pa = pa->next;
        }
        return NULL;
    }
};

超时,在思考优化中。

更新:

这题太精巧了!

初步优化为使用一个hashmap,O(n+m)running time, O(max(n,m))memory. However, there is a better solution.

1. if the tail node of listA isn’t the tail node of listB, return NULL. (No intersection)

2. Count the length of each list, record them as na, nb. Length here means the edge of each node, so it’s equal to number of nodes minus 1.

3. Reverse listA, count the length of listB and record it as nc.

4. The first intersection node is at the ((na+nb+nc) / 2 – na)th node of listB.

O(n+m) running time, O(1) memory.

C++ code:

/**
 * Definition for singly-linked list.
 * struct ListNode {
 *     int val;
 *     ListNode *next;
 *     ListNode(int x) : val(x), next(NULL) {}
 * };
 */
class Solution {
public:
    int countNode(ListNode * head){
        ListNode * p = head;
        int re = 0;
        if(head == NULL){
            return 0;
        }
        while(p != NULL){
            re++;
            p = p->next;
        }
        return re;
    }
    ListNode * findByIndex(ListNode * head, int idx){
        ListNode * p = head;
        while(idx--){
            p = p->next;
        }
        return p;
    }
    ListNode * getTail(ListNode * head){
        if (head == NULL){
            return NULL;
        }
        else{
            while(head->next != NULL){
                head = head->next;
            }
            return head;
        }
    }
    ListNode * reverseList(ListNode * head){
        ListNode *p, *q, *r;
        if(head == NULL){
            return NULL;
        }
        else if(head->next == NULL){
            return head;
        }
        
        else{
            p = head;
            q = head->next;
            head->next = NULL;
            while(q != NULL){
                r = q->next;
                q->next = p;
                p = q;
                q = r;
            }
            return p;
        }
    }
    ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) {
        int k1,k2,k3,n;
        if (headA == NULL || headB == NULL){
            return NULL;
        }
        else if (getTail(headA) != getTail(headB)){
            return NULL;
        }
        k1 = countNode(headA) - 1;
        k2 = countNode(headB) - 1;
        headA = reverseList(headA);
        k3 = countNode(headB) - 1;
        headA = reverseList(headA);
        n = (k1 + k2 + k3) / 2 - k1;
        return findByIndex(headB, n);
    }
};
Code Efficiency

Code Efficiency

Nevertheless, there is still a cleaner and faster solution.

There are many solutions to this problem:

  • Brute-force solution (O(mn) running time, O(1) memory):For each node ai in list A, traverse the entire list B and check if any node in list B coincides with ai.
  • Hashset solution (O(n+m) running time, O(n) or O(m) memory):Traverse list A and store the address / reference to each node in a hash set. Then check every node bi in list B: if bi appears in the hash set, then bi is the intersection node.
  • Two pointer solution (O(n+m) running time, O(1) memory):
    • Maintain two pointers pA and pB initialized at the head of A and B, respectively. Then let them both traverse through the lists, one node at a time.
    • When pA reaches the end of a list, then redirect it to the head of B (yes, B, that’s right.); similarly when pB reaches the end of a list, redirect it the head of A.
    • If at any point pA meets pB, then pA/pB is the intersection node.
    • To see why the above trick would work, consider the following two lists: A = {1,3,5,7,9,11} and B = {2,4,9,11}, which are intersected at node ‘9’. Since B.length (=4) < A.length (=6), pB would reach the end of the merged list first, because pB traverses exactly 2 nodes less than pA does. By redirecting pB to head A, and pA to head B, we now ask pB to travel exactly 2 more nodes than pA would. So in the second iteration, they are guaranteed to reach the intersection node at the same time.
    • If two lists have intersection, then their last nodes must be the same one. So when pA/pB reaches the end of a list, record the last element of A/B respectively. If the two last elements are not the same one, then the two lists have no intersections.

Analysis written by @stellari.

Leave a comment

Your email address will not be published. Required fields are marked *

This site uses Akismet to reduce spam. Learn how your comment data is processed.